#---
# Verify omnibus setup worked as expected.
- name: Verify
  hosts: all
  vars_files:
    - "{{ playbook_dir }}/../../vars/main.yml"
    - "{{ playbook_dir }}/../../defaults/main.yml"
  gather_facts: true
  tasks:
    ###############
    # Test Pre-Install tasks
    ###############
    - name: Gather the package facts
      package_facts:
        manager: auto

    - name: Verify the appropriate packages are installed
      assert:
        that:
          - item in ansible_facts.packages
          - ansible_facts["packages"]["{{ item }}"] | length > 0
        success_msg: "{{ item }} installed correctly."
        fail_msg: "{{ item }} failed install."
      with_items: "{{ requirements }}"
    ###############
    # END Test Pre-Install tasks
    ###############

    ###############
    # Test GitLab App Installation.
    ###############
    - name: TEST - Verify the repository was setup correctly.
      lineinfile:
        name: /etc/apt/sources.list.d/gitlab_gitlab-{{ gitlab_edition }}.list
        line: "deb https://packages.gitlab.com/gitlab/gitlab-{{ gitlab_edition }}/ubuntu/ {{ ansible_distribution_release }} main"
        state: present
      check_mode: yes
      register: aptline
      failed_when: (aptline is changed) or (aptline is failed)
#
#    - name: Does install file still exist?
#      stat: path={{ installation_script.tmp_file }}
#      register: install_file
#
#    - name: TEST - Verify we deleted the repo script
#      assert:
#        that:
#          - not install_file.stat.exists

    - name: TEST - Verify "gitlab-{{ gitlab_edition }}" in ansible_facts.packages
      assert:
        that:
          - '"gitlab-{{ gitlab_edition }}" in ansible_facts.packages'
    - name: TEST - Verify only 1 copy of GitLab is installed
      assert:
        that:
          - ansible_facts["packages"]["gitlab-{{ gitlab_edition }}"] | length == 1
          -
    - name: "version"
      ansible.builtin.debug:
        var: ansible_facts["packages"]["gitlab-{{ gitlab_edition }}"][0]["version"]

    - name: TEST - Verify the correct edition & version of GitLab is installed
      assert:
        that:
          - ansible_facts["packages"]["gitlab-{{ gitlab_edition }}"][0]["version"] == "{{ gitlab_version }}-{{ gitlab_edition }}.0"

    ###############
    # END Test GitLab App Installation.
    ###############


    ################################
    # TEST GitLab License & Config
    ################################

    # ADD TEST HERE TO VERIFY LICENSE

    # Verify gitlab.rb config file generation.
    - name: Copy file with owner and permissions
      ansible.builtin.copy:
        src: "gitlab.rb"
        dest: "{{ files.config }}"
        owner: root
        group: root
        mode: 0600
        check_mode: yes
        register: gitlab_rb
        failed_when: (gitlab_rb is changed) or (gitlab_rb is failed)

    - name: Get gitlab status
      ansible.builtin.command: gitlab-ctl status
      register: gl_status

    # Ensure every service is running.
    # Expected output example: run: sidekiq: (pid 12912) 264620s; run: log: (pid 12926) 264617s
    - name: Ensure the status of each service is running.
      assert:
        that:
          - item is match("run\:\s[\w\-]+\:\s\(pid \d+\)\s\d+s;\srun")
      with_items: "{{ gl_status.stdout.split('\n') }}"
